#!/usr/bin/perl -w

# ./val.pl valasztas.hu/dyn/pv18/szavossz/hu/M*/*/szkjkv_*.html
# also write .csv output
my $CSVfilename='CSV2018.csv';
my ($f, $val, $fieldnr, $fieldname, $ge);
my ($csvcnt, $csvfieldname, $csvfieldnr, $csvvalues); # counter and $csvfieldname hash 0=> filename 1=>fieldname1 2=>fieldname2...
my $arr;
my $globarr={};
# remove &nbsp;
# remove trailing <br>68.23%
# normalize whitespace
# numbers often incorrectly written as '10 764'
sub cleanup
{
	my $s = shift;
	$s =~ s/\&nbsp;//g;
	my $normalized = join ' ', split ' ', $s;       # normalizing whitespace
	$normalized =~ s/\<\s*br\s*\>.*//g;
	return $normalized;
}

# hashref: to global
# also to: csv
sub sumup
{
	if( ! defined $arr){
		print "\nUNDEF ";
		return 0;
	}
	# my $val = $arr->{val}; # numeric by origin (if defined)
	if( ! defined $val ){
		print "SKIP: NOVAL\n";
	} else { # add $val to $globarr
		my $k;
		my $a = $arr->{keys};
		foreach $k (keys %$a){
			print "ADD: $val ; $k\n";
			if($val =~ /^\d+$/){
				$globarr->{$k} += $val;
			} else {
                                
				print STDERR "NOTNUMERIC: $val\n" if( $val !~ /^\s*(.*\%)*$/); # 614<br>76.85 %
			} 
		}
	}
	print "\n.";
}

# fields like GL, IE, IL, ...
# per file and global values
sub sum_IE
{
    my ($k, $v) = @_;
    $globarr->{'SUMS_'. $k} += $v;
    # store into $csvvalues
    if( ! defined $csvfieldnr->{$k} ){ # never seen before
        $csvfieldnr->{$k} = ++$csvcnt;
        $csvfieldname->{$csvcnt} = $k;
    }
    $csvvalues->{$csvfieldnr->{$k}} = $v;
}

sub print_CSV
{
    my ($cnt, $hr) = @_;
    print CSV "\n";
    my $i;
    for($i=0; $i<=$cnt; $i++){ # 0 also defined (filename)
        # my $k = $csvfieldname->{$i};
        my $str = defined $csvvalues->{$i} ? $csvvalues->{$i} : '';
        print CSV $str . ';';
    }
}

# header and sums
sub printsums_CSV
{
    my $i;
    my $header = "\n ;" ;
    my $globsumsline = "\n ;" ;
    for($i=1; $i<=$csvcnt; $i++){
        my $k = $csvfieldname->{$i}; # not defined for 0;
        $header .= $k . ';';
        $globsumsline .= $globarr->{'SUMS_'. $k} . ';' ;
    }
    print CSV $header . $globsumsline . "\n";
}
sub printsums
{
	print "\n---- PRINTSUMS\n";
	my $k;
	foreach $k (sort(keys %$globarr)){
		print "SUM: $globarr->{$k} ; $k\n";
	}
}

sub process_file
{
	my $file=shift;
	open(INFO, $file) or die("Could not open file: $file\n");
#./valasztas.hu/dyn/pv18/szavossz/hu/M01/T002/szkjkv_006.html
# new entry:
my $linenr = 0;
foreach $LINE (<INFO>){
	my $v;
	$linenr++;
	my $l = lc($LINE);	# lowercase ("nemecsek" canonization)
	if($l =~ /\<tr/){ # tr> so new dataline follows. # print "\n;";
		sumup();
		$arr = {};
		$val = undef;
		$ignoreIndex = 0;
		$fieldnr = 0;
	}
	if( ($cell) = ( $l =~ /\>(.+)\<\/td/ )){ # td> so cell content
		my $prev = $val;
		$val = cleanup( $cell );
		if( $val =~ /^\-*[0-9]+$/ ){ # pure numeric
                        $fieldnr++;
			if($fieldnr < 27){
                                my $fk = $fieldname->{$fieldnr};
                                if( defined $fk && $fk =~ /^.{1,3}$/ ){
                                    print "ADDSUMS: $fk $val $csvvalues->{0}\n";
                                    sum_IE( $fk, $val );
                                    $ge = $val if( $fk eq 'ge' );
                                    print "ERROR:IE_gt_GE: ie=$val ge=$ge\n" if($fk eq 'ie' && $val > $ge); # ie comes later than ge in the reports (ge often missing)
                                    delete $fieldname->{$fieldnr}; # NO reuse in case of bogus report format
                                } else { 
                                    print "UNKNOWN_SUMFIELD: fieldnr=$fieldnr ; $val ($l) \n";
                                }
			}
			next if(0 == $ignoreIndex++); # first number after </tr> is technical index, not to sum
			if( defined $prev ){ # already contains val ? OK during header processing
				print " METATR: REASSIGN_VAL $prev to $val according to linenr=$linenr : $l\n";
			} # should skip whole TR ?
			# $arr->{val}=$val;
			print " VAL=$val ";
		} else { # unintentionally merging personal name collisions:
			# KEY=tóth endre KEY=jobbik
			# KEY=tóth endre KEY=momentum
			$arr->{keys}->{$val} ++; 
			print "linenr=$linenr; KEY=$val ";
		}
	} elsif(($cell) = ( $l =~  /\>\s*(.{1,3})\s*\<\/th/ )){ # th> header content <th>NE</th>
                $fieldnr++ ;
                $fieldname->{$fieldnr}=$cell;
		print STDERR "fieldname: $fieldnr = $cell\n";
# <th>OE</th>
# <th>KE</th>
# <th>LE</th>
# <th>ME</th>
# <th>NE</th>
	}
} # foreach
} # sub process_file

open CSV, '>' . $CSVfilename;

# ----- main()
my $filenr=0;
foreach $f (@ARGV){
	$filenr ++;
	print "\n---- NEWFILE $filenr $f\n";
	$fieldnr = 9999;        # invalid value
	$ge=0;
	$csvvalues = {0 => $f}; # delete all other keys
	process_file($f);
        print_CSV( $csvcnt, $csvvalues );
}

printsums();
printsums_CSV();

# <tr>
# NEGLECT first line (index)
#  <td style="text-align:center;">&nbsp;6&nbsp;</td>
#  <td> Varga Mihály</td>
#  <td>FIDESZ-KDNP</td>
#  <td style="text-align:right;">&nbsp;320&nbsp;</td>
#</tr>
# <td>&nbsp;566&nbsp;</td>
# </tr>
# 
